<?php
/*
 * Copyright (C) 2014 Velvary Pty Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace VanillaBeans\SlackHooker;

// If this file is called directly, abort.
if (!defined('WPINC')) {
    die;
}

function RegisterSettings() {
    register_setting('vbean-slack-hooker-settings', 'vbean_slack_hooker_webhookurl');
    register_setting('vbean-slack-hooker-settings', 'vbean_slack_hooker_defaultchannel');
    register_setting('vbean-slack-hooker-settings', 'vbean_slack_hooker_defaultusername');
    register_setting('vbean-slack-hooker-settings', 'vbean_slack_hooker_defaulticon');
    register_setting('vbean-slack-hooker-settings', 'vbean_slack_hooker_sendtest');
    register_setting('vbean-slack-hooker-settings', 'vbean_slack_hooker_testcontent');
    register_setting('vbean-slack-hooker-settings', 'vbean_slack_hooker_loginalert');
    register_setting('vbean-slack-hooker-settings', 'vbean_slack_hooker_commentalert');
    register_setting('vbean-slack-hooker-settings', 'vbean_slack_hooker_commentalertcontent');
    register_setting('vbean-slack-hooker-settings', 'vbean_slack_hooker_limitfrequency');
    register_setting('vbean-slack-hooker-settings', 'vbean_slack_hooker_maximumper');
    register_setting('vbean-slack-hooker-settings', 'vbean_slack_hooker_maximumperseconds');
    
}

function SettingsPage() {
    ?>

    <style>
        .pixelplug{display:none;}
        .vbeg{font-weight: bold;font-family: courier, 'courier new';background:#fff;border: 1px solid maroon;padding:5px;}
    </style>

    <div class="wrap">
        <h2>Vanilla Bean Slack Message Settings</h2>
        <p>This plugin is designed to provide alerts and messages from your wordpress to your slack channel(s).</p>
        <p>


        </p>

        <form method="post" action="options.php">

            <?php
            settings_fields('vbean-slack-hooker-settings');
            $vb_slackwebhook = get_option('vbean_slack_hooker_webhookurl');
            $vb_slackchannel = get_option('vbean_slack_hooker_defaultchannel');
            $vb_slackuser = get_option('vbean_slack_hooker_defaultusername');
            $vb_sendtest = get_option('vbean_slack_hooker_sendtest');
            $vb_icon = get_option('vbean_slack_hooker_defaulticon');
            $vb_testcontent = get_option('vbean_slack_hooker_testcontent');
            $maximumper = get_option('vbean_slack_hooker_maximumper');
            $maximumperseconds = get_option('vbean_slack_hooker_maximumperseconds');
            $limitfrequency = get_option('vbean_slack_hooker_limitfrequency');
            if (empty($vb_testcontent)) {
                $vb_testcontent = 'This is a test slack notification from your wordpress';
            }
            update_option('vbean_slack_hooker_sendtest', NULL);
            ?>

           


    <?php
    do_settings_sections('vbean-slack-hooker-settings');

    if ($vb_sendtest == '1') {
        // send a test message to the api
        $slack = \VanillaBeans\SlackHooker\vbean_slackhooker($vb_testcontent,$vb_slackchannel,$vb_slackuser,$vb_icon,false);

        if( is_wp_error( $slack ) ) {
                update_option('vbean_slack_hooker_setupvalid', NULL);
            echo '<pre style="color:red;">';
            echo $slack->get_error_message();
            echo '</pre>';
        }elseif(!empty ($slack['response'])){
            if($slack['body']=='ok'){
                echo '<pre style="font-size:16px;color:lime;text-shadow:1px 1px black;font-weight:bold;">';
                echo 'Success!';
                echo '</pre>';
                update_option('vbean_slack_hooker_setupvalid', 'yes');
            }else{
                update_option('vbean_slack_hooker_setupvalid', NULL);
                echo '<pre style="font-size:16px;color:maroon;text-shadow:1px 1px black;font-weight:bold;">';
                echo 'Failure: '.  substr($slack['body'], 0, 500);
                echo '</pre>';
            }
        }else{
                if($slack=='delayed'){
                    echo '<pre style="font-size:16px;color:blue;text-shadow:1px 1px black;font-weight:bold;">';
                    echo 'Send Scheduled. Please check your slack channel';
                    echo '</pre>';
                    update_option('vbean_slack_hooker_setupvalid', 'yes');
                }else if($slack=='ok'){
                    echo '<pre style="font-size:16px;color:lime;text-shadow:1px 1px black;font-weight:bold;">';
                    echo 'Success!';
                    echo '</pre>';
                    update_option('vbean_slack_hooker_setupvalid', 'yes');
                }else{
                update_option('vbean_slack_hooker_setupvalid', NULL);
            // failed
                    echo '<pre style="font-size:16px;color:red;text-shadow:1px 1px black;font-weight:bold;">';
                    echo 'Failure: No response was returned<br />'.$slack;
                    echo '</pre>';
                    
                }
        }
    }
    
    
    ?>
            

<div style="border:groove;padding:10px;background:#cfcfcf;">
Provides shortcode and function access to Slack's incoming webhook to your slack application.<br />
eg: <br />
<p class="vbeg">&#91;slackhooker text="Here is a demo message from my wordpress - <?php echo(get_option('siteurl')) ?>"&#93;</p>
or 
<p class="vbeg">&#91;slackhooker text="Here is a demo message with specified channel from <?php echo(get_option('siteurl')) ?>" channel="general" username="<?php echo(get_option('siteurl')) ?>"&#93;</p>

Messages are set as wordpress cron jobs to insure page processing is not interrupted, but you can override:
<p class="vbeg">&#91;slackhooker text="Here is an instant demo message from my wordpress - <?php echo(get_option('siteurl')) ?>." sendnow="true"&#93;</p>

You can override your default Webhook with a different webhook by using 'postto':
<p class="vbeg">&#91;slackhooker text="Here is a message to specified webhook(s) from <?php echo(get_option('siteurl')) ?>." postto="https://hooks.slack.com/services/T03TDTDUF/ABCDEFGHIJ/abcdeFgHiJKLmmnoPQrsZ"&#93;</p>


Or you can specify additional Webhooks by using 'alsoto' :
<p class="vbeg">&#91;slackhooker text="Here is a message to additional webhooks - <?php echo(get_option('siteurl')) ?>." alsoto="https://hooks.slack.com/services/T03TDTDUF/ABCDEFGHIJ/abcdeadsfadsfasdsfasd"&#93;</p>


= Programmatic Examples =
<pre style='border:2px inset;padding:5px;'>
if(function_exists('\VanillaBeans\SlackHooker\vbean_slackhooker')){
    \VanillaBeans\SlackHooker\vbean_slackhooker('Here is my notification');
 }

if(function_exists('\VanillaBeans\SlackHooker\vbean_slackhooker')){
    \VanillaBeans\SlackHooker\vbean_slackhooker('Send nudes','mychannel','Username',':specific_icon:');
 }

if(function_exists('\VanillaBeans\SlackHooker\vbean_slackhooker')){
    \VanillaBeans\SlackHooker\vbean_slacknotify(array('text'=>'Here is my notification','icon'=>':open_mouth:'));
 }
</pre>

</div>
           
            
            <table class="form-table">


                <tr valign="top">
                    <th scope="row">Default Webhook URL</th>
                    <td><textarea cols="80" rows="4" class="text" name="vbean_slack_hooker_webhookurl"  id="vbean_slack_hooker_webhookurl" /><?php echo $vb_slackwebhook ?></textarea>
                        <div class="description">The Webhook URL provided by your slack application.<br />It looks something like:<br>https://hooks.slack.com/services/T03TDTDUF/ABCDEFGHIJ/abcdeFgHiJKLmmnoPQrsZ<br />You may add more than one channel here separated by commas.</div>
                        <div class="important">Do not add more than one URL unless you intend for ALL slack notifications to go to all urls.</div>
                    </td>
                </tr>


                
                <tr valign="top">
                    <th scope="row">Default Channel</th>
                    <td><input type="text" class="text" name="vbean_slack_hooker_defaultchannel"  id="vbean_slack_hooker_defaultchannel" value="<?php echo $vb_slackchannel ?>" style="width:300px;" />
                        <div class="description">The default channel .</div>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">Default Username</th>
                    <td><input type="text" class="text" name="vbean_slack_hooker_defaultusername"  id="vbean_slack_hooker_defaultusername" value="<?php echo $vb_slackuser ?>" style="width:300px;" />
                        <div class="description">The default username posted to the slack channel .</div>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">Default Icon</th>
                    <td><input type="text" class="text" name="vbean_slack_hooker_defaulticon"  id="vbean_slack_hooker_defaulticon" value="<?php echo get_option('vbean_slack_hooker_defaulticon') ?>" style="width:300px;" />
                        <div class="description">Leave blank to use your Slack app default.</div>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">Send a test to your slack channel</th>
                    <td colspan="2"><input type="checkbox" class="checkbox" name="vbean_slack_hooker_sendtest"  id="vbean_slack_hooker_sendtest" value="1" />Send Test
                        <div class="description"></div>
                    </td>
                </tr>
                <tr valign="top" id="testcontent">
                    <th scope="row">Test message content</th>
                    <td><textarea cols="60" rows="3" name="vbean_slack_hooker_testcontent" id="vbean_slack_hooker_testcontent"><?php echo $vb_testcontent ?></textarea>
                        <div class="description"></div>
                    </td>
                </tr>



                <tr valign="top">
                    <th scope="row">Default notifications:</th>
                    <td colspan="2">
                        <label for="vbean_slack_hooker_commentalert"><input type="checkbox" class="checkbox" name="vbean_slack_hooker_commentalert"  id="vbean_slack_hooker_commentalert" value="1" <?php echo checked(1, get_option('vbean_slack_hooker_commentalert'), false)   ?> />When a comment is posted</label> &nbsp;&nbsp; <label for="vbean_slack_hooker_commentalertcontent"><input type="checkbox" class="checkbox" name="vbean_slack_hooker_commentalertcontent"  id="vbean_slack_hooker_commentalertcontent" value="1" <?php echo checked(1, get_option('vbean_slack_hooker_commentalertcontent'), false)   ?> />include the content</label><br />
                        <div class="description"></div>
                    </td>
                </tr>                
                
                <tr valign="top">
                    <th scope="row">Limit Frequency</th>
                    <td colspan="2"><input type="checkbox" class="checkbox" name="vbean_slack_hooker_limitfrequency"  id="vbean_slack_hooker_limitfrequency" value="1" <?php echo checked(1, get_option('vbean_slack_hooker_limitfrequency'), false)   ?> />Limit to 
                        <select name="vbean_slack_hooker_maximumper" id="vbean_slack_hooker_maximumper">
   <?php 
                                for($i=1;$i<30;$i++){
                                    
                                $s = "<option value ='$i' ";
                                if($maximumper==$i){
                                    
                                    
                                    $s.=' SELECTED';
                                }
                                
                                $s.='>'.$i.'</option>';
                                  echo $s;  
                                }
                            
                            
                            ?>                            
                        </select>
                        messages sent  
                        <select name="vbean_slack_hooker_maximumperseconds" id="vbean_slack_hooker_maximumperseconds">
                            <?php 
                                $every = 'per second';
                                for($i=1;$i<30;$i++){
                                    if($i>1){
                                        $every = 'every '.$i.' seconds.';
                                    }
                                $s = "<option value ='$i' ";
                                if($maximumperseconds==$i){
                                    $s.=' SELECTED';
                                }
                                $s.='>'.$every.'</option>';
                                
                                echo $s;
                                
                                
                            }?>
                            
                        </select>
                        
                        .
                        <div class="description">This is a safeguard against your site firing thousands of messages due to heavy traffic or if you are using it in conjunction with error reporting. It is highly recommended that you leave this switched on.</div>
                    </td>
                </tr>
                
            </table>
 

            <span class="pixelplug"><img src="https://stage.velvary.com.au/wpi/img/vanilla-slack-message.png" width="1" height="1"></span>

            <?php submit_button(); ?>
        </form>
    </div>    

    <?php
}
